# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define section free
%define namedversion 1.4.3.GA

Name:           jboss-messaging
Version:        1.4.3
Release:        2%{?dist}
Epoch:          0
Summary:        JBoss Messaging
License:        LGPL
Group:          Development/Java
URL:            http://www.jboss.org/
Source0:        jboss-messaging-1.4.3.tar.gz
# svn export http://anonsvn.jboss.org/repos/messaging/tags/JBossMessaging_1_4_3_GA/ jboss-messaging-1.4.3
Source1:        jboss-messaging-thirdparty-libraries.ent
Source2:        http://repository.jboss.com/maven2/jboss/messaging/jboss-messaging/1.4.3.GA/jboss-messaging-1.4.3.GA.pom
Source3:        http://repository.jboss.com/maven2/jboss/messaging/jboss-messaging-client/1.4.3.GA/jboss-messaging-client-1.4.3.GA.pom
Source4:        http://repository.jboss.com/maven2/jboss/messaging/resources/1.4.3.GA/resources-1.4.3.GA.pom
Patch0:         jboss-messaging-build.patch

BuildArch:      noarch
Requires(post): jpackage-utils >= 0:1.7.3
Requires(postun): jpackage-utils >= 0:1.7.3
BuildRequires:  jpackage-utils >= 0:1.7.3
BuildRequires:  java-devel >= 0:1.6.0
BuildRequires:  ant
BuildRequires:  ant-nodeps
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root
BuildRequires:  concurrent
BuildRequires:  dom4j
BuildRequires:  dtdparser
BuildRequires:  gnu-trove
BuildRequires:  hsqldb
BuildRequires:  jakarta-commons-el
BuildRequires:  jakarta-commons-logging
BuildRequires:  jakarta-commons-modeler
BuildRequires:  javacc3
BuildRequires:  javassist
BuildRequires:  jboss-aop
BuildRequires:  jboss-common-core
BuildRequires:  jboss-common-logging-jdk
BuildRequires:  jboss-common-logging-log4j
BuildRequires:  jboss-common-logging-spi
BuildRequires:  jboss-javaee
BuildRequires:  jboss-mdr
BuildRequires:  jboss-profiler
BuildRequires:  jboss-remoting
BuildRequires:  jboss-serialization
BuildRequires:  jbossas
BuildRequires:  jbossts
BuildRequires:  jbossxb2
BuildRequires:  jgroups
BuildRequires:  junit
BuildRequires:  log4j
BuildRequires:  snmptrapappender
BuildRequires:  xerces-j2
BuildRequires:  xml-commons-jaxp-1.3-apis
BuildRequires:  xml-commons-resolver12

%description
JBoss Messaging.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation

%description javadoc
%{summary}.

%prep
%setup -q 
%patch0 -b .sav0

mkdir -p thirdparty
cp %{SOURCE1} thirdparty/libraries.ent
mkdir -p thirdparty/apache-log4j/lib
ln -sf $(build-classpath log4j) thirdparty/apache-log4j/lib/log4j.jar
mkdir -p thirdparty/snmptrapappender/lib
ln -sf $(build-classpath snmptrapappender) thirdparty/apache-log4j/lib/snmpTrapAppender.jar
mkdir -p thirdparty/apache-logging/lib
ln -sf $(build-classpath commons-logging) thirdparty/apache-logging/lib/commons-logging.jar
#thirdparty/apache-logging/lib/commons-logging-src.zip
mkdir -p thirdparty/apache-modeler/lib
ln -sf $(build-classpath commons-modeler) thirdparty/apache-modeler/lib/commons-modeler.jar
mkdir -p thirdparty/apache-tomcat/lib
#thirdparty/apache-tomcat/lib/catalina.jar
#thirdparty/apache-tomcat/lib/catalina-manager.jar
#thirdparty/apache-tomcat/lib/catalina-optional.jar
#thirdparty/apache-tomcat/lib/jasper-compiler.jar
#thirdparty/apache-tomcat/lib/jasper-compiler-jdt.jar
#thirdparty/apache-tomcat/lib/jasper-runtime.jar
#thirdparty/apache-tomcat/lib/naming-resources.jar
#thirdparty/apache-tomcat/lib/servlets-default.jar
#thirdparty/apache-tomcat/lib/servlets-invoker.jar
#thirdparty/apache-tomcat/lib/servlets-webdav.jar
#thirdparty/apache-tomcat/lib/tomcat-ajp.jar
#thirdparty/apache-tomcat/lib/tomcat-apr.jar
#thirdparty/apache-tomcat/lib/tomcat-coyote.jar
#thirdparty/apache-tomcat/lib/tomcat-http.jar
#thirdparty/apache-tomcat/lib/tomcat-util.jar
mkdir -p thirdparty/apache-xerces/lib
ln -sf $(build-classpath xerces-j2) thirdparty/apache-xerces/lib/xercesImpl.jar
ln -sf $(build-classpath xml-commons-resolver12) thirdparty/apache-xerces/lib/resolver.jar
ln -sf $(build-classpath xml-commons-jaxp-1.3-apis) thirdparty/apache-xerces/lib/xml-apis.jar
mkdir -p thirdparty/commons-el/lib
ln -sf $(build-classpath commons-el) thirdparty/commons-el/lib/commons-el.jar
mkdir -p thirdparty/dom4j/lib
ln -sf $(build-classpath dom4j) thirdparty/dom4j/lib/dom4j.jar
mkdir -p thirdparty/hsqldb/lib
ln -sf $(build-classpath hsqldb) thirdparty/hsqldb/lib/hsqldb.jar
mkdir -p thirdparty/javassist/lib
ln -sf $(build-classpath javassist) thirdparty/javassist/lib/javassist.jar
mkdir -p thirdparty/jboss/aop/lib
ln -sf $(build-classpath jboss-aop/jboss-aop) thirdparty/jboss/aop/lib/jboss-aop.jar
ln -sf $(build-classpath jboss-aop/jboss-aop-jdk50-client) thirdparty/jboss/aop/lib/jboss-aop-client.jar
ln -sf $(build-classpath jboss-aop/pluggable-instrumentor) thirdparty/jboss/aop/lib/pluggable-instrumentor.jar
#thirdparty/jboss/aop/lib/jboss-aop-asintegration-core.jar
#thirdparty/jboss/aop/lib/jboss-aop-asintegration-jmx.jar
#thirdparty/jboss/aop/lib/jboss-aop-asintegration-mc.jar
#thirdparty/jboss/aop/lib/jboss-aop-client.jar
#thirdparty/jboss/aop/lib/jboss-standalone-aspect-library-jdk50.jar
#thirdparty/jboss/aop/lib/jrockit-pluggable-instrumentor.jar
mkdir -p thirdparty/jbossas/core-libs/lib
ln -sf $(build-classpath jboss-common-core) thirdparty/jbossas/core-libs/lib/jboss-common.jar
#thirdparty/jbossas/core-libs/lib/jboss-common-jdbc-wrapper.jar
#thirdparty/jbossas/core-libs/lib/jbosscx-client.jar
ln -sf $(build-classpath jboss-javaee) thirdparty/jbossas/core-libs/lib/jboss-j2ee.jar
ln -sf $(build-classpath jbossas/jboss) thirdparty/jbossas/core-libs/lib/jboss.jar
#thirdparty/jbossas/core-libs/lib/jboss-jca.jar
ln -sf $(build-classpath jbossas/jboss-jmx) thirdparty/jbossas/core-libs/lib/jboss-jmx.jar
#thirdparty/jbossas/core-libs/lib/jboss-local-jdbc.jar
ln -sf $(build-classpath jbossas/jbosssx-client) thirdparty/jbossas/core-libs/lib/jbosssx-client.jar
ln -sf $(build-classpath jbossas/jboss-system) thirdparty/jbossas/core-libs/lib/jboss-system.jar
ln -sf $(build-classpath jbossas/jboss-transaction-client) thirdparty/jbossas/core-libs/lib/jboss-transaction-client.jar
#thirdparty/jbossas/core-libs/lib/jboss-xml-binding.jar
#thirdparty/jbossas/core-libs/lib/jms-ra.jar
#thirdparty/jbossas/core-libs/lib/jnp-client.jar
#mkdir -p thirdparty/jboss/backport-concurrent/lib
#thirdparty/jboss/backport-concurrent/lib/jboss-backport-concurrent.jar
mkdir -p thirdparty/jboss/common/lib
ln -sf $(build-classpath jboss-logging-spi) thirdparty/jboss/common/lib/jboss-common-client.jar
ln -sf $(build-classpath jboss-common-core) thirdparty/jboss/common/lib/jboss-common.jar
#thirdparty/jboss/common/lib/jboss-common-sources.jar
#thirdparty/jboss/common/lib/namespace.jar
mkdir -p thirdparty/jboss/common-logging-jdk/lib
ln -sf $(build-classpath jboss-common-logging-jdk) thirdparty/jboss/common-logging-jdk/lib/jboss-logging-jdk.jar
#thirdparty/jboss/common-logging-jdk/lib/jboss-logging-jdk-sources.jar
mkdir -p thirdparty/jboss/common-logging-log4j/lib
ln -sf $(build-classpath jboss-common-logging-log4j) thirdparty/jboss/common-logging-log4j/lib/jboss-logging-log4j.jar
#thirdparty/jboss/common-logging-log4j/lib/jboss-logging-log4j-sources.jar
mkdir -p thirdparty/jboss/common-logging-spi/lib
ln -sf $(build-classpath jboss-common-logging-spi) thirdparty/jboss/common-logging-spi/lib/jboss-logging-spi.jar
#thirdparty/jboss/common-logging-spi/lib/jboss-logging-spi-sources.jar
mkdir -p thirdparty/jboss/jboss-mdr/lib
ln -sf $(build-classpath jboss-mdr) thirdparty/jboss/jboss-mdr/lib/jboss-mdr.jar
#thirdparty/jboss/jboss-mdr/lib/jboss-mdr-sources.jar
mkdir -p thirdparty/jboss/jbossretro-rt/lib
#thirdparty/jboss/jbossretro-rt/lib/jbossretro-rt.jar
mkdir -p thirdparty/jboss/jbossts/lib
#thirdparty/jboss/jbossts/lib/jbossjta-integration.jar
ln -sf $(build-classpath jbossts/jbossjta) thirdparty/jboss/jbossts/lib/jbossjta.jar
ln -sf $(build-classpath jbossts/jbossts-common) thirdparty/jboss/jbossts/lib/jbossts-common.jar
mkdir -p thirdparty/jboss/jbossxb/lib
ln -sf $(build-classpath jboss/jbossxb2) thirdparty/jboss/jbossxb/lib/jboss-xml-binding.jar
#thirdparty/jboss/jbossxb/lib/jboss-xml-binding-sources.jar
mkdir -p thirdparty/jboss/profiler/jvmti/lib
ln -sf $(build-classpath jboss-profiler/jboss-profiler-jvmti) thirdparty/jboss/profiler/jvmti/lib/jboss-profiler-jvmti.jar
mkdir -p thirdparty/jboss/remoting/lib
ln -sf $(build-classpath jboss-remoting) thirdparty/jboss/remoting/lib/jboss-remoting.jar
#thirdparty/jboss/remoting/lib/jboss-remoting-src.jar
mkdir -p thirdparty/jboss/serialization/lib
ln -sf $(build-classpath jboss-serialization) thirdparty/jboss/serialization/lib/jboss-serialization.jar
mkdir -p thirdparty/jboss/test14/lib
#thirdparty/jboss/test14/lib/jboss-test14.jar
mkdir -p thirdparty/jgroups/lib
ln -sf $(build-classpath jgroups) thirdparty/jgroups/lib/jgroups.jar
#thirdparty/jgroups/lib/jgroups-sources.jar
mkdir -p thirdparty/junit/lib
ln -sf $(build-classpath junit) thirdparty/junit/lib/junit.jar
mkdir -p thirdparty/oswego-concurrent/lib
ln -sf $(build-classpath concurrent) thirdparty/oswego-concurrent/lib/concurrent.jar
mkdir -p thirdparty/retrotranslator/lib
#thirdparty/retrotranslator/lib/backport-util-concurrent.jar
#thirdparty/retrotranslator/lib/retrotranslator-runtime.jar
#thirdparty/retrotranslator/lib/retrotranslator-transformer.jar
mkdir -p thirdparty/sun-javacc/lib
ln -sf $(build-classpath javacc3) thirdparty/sun-javacc/lib/javacc.jar
mkdir -p thirdparty/trove/lib
ln -sf $(build-classpath gnu-trove) thirdparty/trove/lib/trove.jar
mkdir -p thirdparty/wutka-dtdparser/lib
ln -sf $(build-classpath dtdparser) thirdparty/wutka-dtdparser/lib/dtdparser.jar


%build
export JAVA_HOME=%{_jvmdir}/java-1.6.0
ant release-bundle
mkdir resources
cp output/etc/server/default/deploy/*-service.xml resources
jar cf resources.jar resources

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}
install -m 644 release/%{name}-%{namedversion}/%{name}-client.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-client-%{version}.jar
install -m 644 release/%{name}-%{namedversion}/%{name}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
install -m 644 resources.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-resources-%{version}.jar
%add_to_maven_depmap org.jboss.messaging %{name} %{namedversion} JPP %{name}
%add_to_maven_depmap jboss.messaging %{name} %{namedversion} JPP %{name}
%add_to_maven_depmap jboss.messaging resources %{namedversion} JPP %{name}-resources

(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

# poms
install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms
install -m 644 %{SOURCE2} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom
install -m 644 %{SOURCE3} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-client.pom
install -m 644 %{SOURCE4} $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-resources.pom

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -rf release/%{name}-%{namedversion}/api/* \
                  $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

%clean
rm -rf $RPM_BUILD_ROOT

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%{_javadir}/*
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*

%files javadoc
%defattr(-,root,root,-)
%doc %{_javadocdir}/%{name}-%{version}
%doc %{_javadocdir}/%{name}

%changelog
* Fri Aug 29 2009 Ralph Apel <r.apel@r-apel.de> - 0:1.4.3-2
- Add -resources jar
- Add -client, -resources poms from repo
- Add  depmap frags

* Mon Jun 29 2009 Ralph Apel <r.apel@r-apel.de> - 0:1.4.3-1.jpp5
- first release

